T     = size(y,1);
k     = size(X,2);
b     = inv(Xhat'*X)*Xhat'*y;
yhat  = X*b;
u     = y-yhat;
SSE   = (u-mean(u))'*(u-mean(u));
s2    = SSE /(T-k);
S     = s2*inv(Xhat'*X);
stdb  = sqrt(diag(S));
Yhat  = Xhat*b;
SSR   = (Yhat-mean(Yhat))'*(Yhat-mean(Yhat));
r2    = SSR / (SSR+SSE);                                             % As reported by SAS and SPSS. Fstat should be based ...
fstat = (r2/(k-1)) / ((1-r2)/(T-k));                                 % ... on this r2
