if ~SEPUTIL
  cutH = 0*mean(mean(Hsim(ss)));
  Hs0=Hsim(ss);
  Hs1=Hsim(ss-nAg);
  kk = find(Hs0>cutH & Hs1>cutH);
  kk = find(Hs0<2 & Hs1<2);
  ii = intersect(ii,kk);
  n  = length(ii);
end

[x_Z, x_Zprob] = tauchen(ggz,0,rho,sigma,m); x_Z=x_Z';
x_distr = (ones(1,ggz)/ggz) * x_Zprob^1000;
x_Ql = exp(x_Z - sigma_perm);
x_Qh = exp(x_Z + sigma_perm);
x_EQ = x_distr * (x_Ql' + x_Qh') / 2;
x_varz = (sigma^2)/(1-rho^2);
x_iz=iZ_lag(ii);
i1=find(x_iz<=ggz);
i2=find(x_iz>ggz);
pred_dw1=zeros(n,1);
pred_dw1(i1) = (rho-1)*(x_Z(x_iz(i1))+Xsim(i1)')*x_varz/(x_varz+varX);
pred_dw1(i2) = (rho-1)*(x_Z(x_iz(i2)-ggz)+Xsim(i2)')*x_varz/(x_varz+varX);



y     = Dh(ii);
Xhat  = [ones(n,1) pred_dw1];
X     = [ones(n,1) Dw(ii)];
TWOSLS
THb   = b;
THr2  = r2;
THst  = stdb;
THf   = fstat;

Z     = [ones(n,1) lag_Dw(ii) lag_w(ii)];
IV1b  = inv(Z'*Z)*Z'*Dw(ii);
pred_dw = Z*IV1b;
if USE_ALL_IN_1ST_STAGE 
    Xhat = [ones(n,1) save_pred_dw(ii)];
else
    Xhat  = [ones(n,1) Z*IV1b];
end
TWOSLS
eps   = X(:,2) - Xhat(:,2);
IV1r2 = 1 - (eps'*eps) / ((X(:,2)-mean(X(:,2)))'*(X(:,2)-mean(X(:,2))));
s     = eps'*eps / n;
st    = inv(Z'*Z)*s;
IV1st = sqrt(diag(st));
k     = size(Z,2);
IV1f  = (IV1r2 / (k-1)) / ((1-IV1r2)/(n-k));

IV2b  = b;
IV2r2 = r2;
IV2st = stdb;
IV2f  = fstat;


% Regress h on w and c
x       = [ones(n,1) w(ii) c(ii)];
LEVb    = inv(x'*x)*x'*h(ii);
pred_h0 = x*LEVb;
eps     = h(ii)-pred_h0;
LEVr2   = 1 - (eps'*eps) / ((h(ii)-mean(h(ii)))'*(h(ii)-mean(h(ii))));
s       = eps'*eps / n;
st      = inv(x'*x)*s;
LEVst   = sqrt(diag(st));
k       = size(x,2);
LEVf    = (LEVr2 / (k-1)) / ((1-LEVr2)/(n-k));



% Regress DH on Dw and constant (semi log)
y     = DH(ii);
Xhat  = [ones(n,1) pred_dw1];
X     = [ones(n,1) Dw(ii)];
TWOSLS
SLb   = b;
SLr2  = r2;
SLst  = stdb;
SLf   = fstat;
